﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using CG2.Mathematics;
using CG2.Rendering;

namespace CG2.Lighting
{
    public class PointLight : Light
    {
        #region Properties

        // ToDo: declare Origin and Range of point light
        // ToDo: declare Linear and Quadratic attenuation factors
        public Vector4 Origin;
        public Double Range = 1;
        public Double LinearAttenuation = 1.0;
        public Double QuadraticAttenuation = 0.0;

        #endregion

        #region Lighting

        public override Double GetIntensityAt(Vector4 point)
        {
            // ToDo: Implement linear/quadratic light attenuation based on distance of point from light
            // Hint: Use > http://goo.gl/j9I6t 

            Vector4 LightVector = Origin - point;
            Double D = LightVector.Length;
            Double Range2 = Range * Range;

            Double LinearDecay = Range / (Range + LinearAttenuation * D);
            Double QuadraticDecay = Range2 / (Range2 + QuadraticAttenuation * D * D);

            // Blender
            return Intensity * LinearDecay * QuadraticDecay; 
        }

        public override void SetLightRayAt(Vector4 point, Ray ray)
        {
            Vector4 l = Origin - point;
            Double d = l.Length;
            ray.Set(point, (1.0 / d) * l);
            ray.HitParam = d;
        }

        #endregion
    }
}
