﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using CG2.Mathematics;
using System.Drawing;

namespace CG2.Texturing
{
	public enum TextureWrap
	{
		Clamp,
		Repeat,
		Mirror
	}

	public enum TextureFiltering
	{
		Nearest,
		Bilinear,
	}

	public class Texture2Sampler : Sampler
	{
		#region Properties

        // Bitmap which holds the raw image data
		public Bitmap Bitmap;
		
        public TextureMapping Mapping = new TextureMapping();

        // Filtering for sub-sampling 
		public TextureFiltering Filtering = TextureFiltering.Nearest;

        // Wrapping types WrapU, WrapV for U and V axes
		public TextureWrap WrapU = TextureWrap.Clamp;
		public TextureWrap WrapV = TextureWrap.Clamp;

		#endregion


		#region Init

		public Texture2Sampler()
		{
		}

		public Texture2Sampler(String bitmapFile, TextureMapping mapping, TextureFiltering filtering, TextureWrap wrapU, TextureWrap wrapV)
		{
            // ToDo: Init given parameters
		}

		#endregion


		#region Sampler

		public override Vector4 GetSample(Vector4 point)
		{
			// get sampling coordinates using mapping - important
			Vector4 uvw = Mapping.GetCoords(point);

			switch (WrapU)
			{
				case TextureWrap.Clamp:
                    // ToDo: implement clamp wrapping of texture coordinates (uvw) in U
                    // Hint: if u < 0 set u = 0. if u > 0 set u = 1
					break;

				case TextureWrap.Repeat:
                    // ToDo: implement repeat wrapping of texture coordinates (uvw) in U
                    // Hint: u = u - floor(u)
					break;

				case TextureWrap.Mirror:
                    // ToDo: implement mirror wrapping of texture coordinates (uvw) in U
                    // Hint: u = u - floor(u); if floor(u) is even u = 1 - u;
					break;
			}

			switch (WrapV)
			{
				case TextureWrap.Clamp:
                    // ToDo: implement clamp wrapping of texture coordinates (uvw) in V
					break;

				case TextureWrap.Repeat:
                    // ToDo: implement repeat wrapping of texture coordinates (uvw) in V
					break;

				case TextureWrap.Mirror:
                    // ToDo: implement mirror wrapping of texture coordinates (uvw) in V
					break;
			}

			switch (Filtering)
			{
				case TextureFiltering.Nearest:
                    // ToDo: Implement nearest neighbor texture sampling
                    // Hint: Color c is from pixel[x = floor(uvw.X*(Bitmap.Width-2)), ...]
                    //       resulting color should be in RGB				
                    return Vector4.Zero;

				case TextureFiltering.Bilinear:
                    // ToDo: Implement bilinear neighbor texture sampling
                    // Hint: u = uvw.X*(Bitmap.Width-2); v = ...; 
                    //       u1 = u-floor(u); v1 = ...; 
                    //       u0 = 1 - u1; v0 = ...; 
                    //       Sample 4 pixels at {c00,c01,c10,c11} = (u..u+1, v..v+1); 
                    //       Final color is: c = (c00*u0 + c10*u1)*v0 + (c01*u0 + c11*u1)*v1 ) 

                    return Vector4.Zero;

			}

			return Vector4.Zero;
		}

		#endregion
	}
}
